#!/usr/bin/python

import csv
import datetime
import sqlobject
import sys

__connection__ = sqlobject.connectionForURI("mysql://PyAuthD:"+sys.argv[1]+"@localhost/auth")

class users(sqlobject.SQLObject):

    # Name.
    vorname = sqlobject.StringCol(length=255)
    nachname = sqlobject.StringCol(length=255)

    # Persoenliche Informationen.
    gebdat = sqlobject.DateCol()
    semester = sqlobject.IntCol()
    fach = sqlobject.ForeignKey("Fach")

    # Account Informationen.
    matnr = sqlobject.IntCol()
    alias = sqlobject.StringCol(length=255)
    passwd = sqlobject.StringCol(length=255)

class fach(sqlobject.SQLObject):

    # Fachname.
    name = sqlobject.StringCol(length=255)

    # Joins.
    users = sqlobject.MultipleJoin("User")

class DataContainer(csv.excel):
    delimiter = ";"

def openData(fname):
    # Open reader and skip first line (column headings).
    rd = csv.reader(file(fname),dialect=DataContainer)
    rd.next()
    return rd

def parseDate(date):
    # Split, and encode as date object.
    tt, mm, jjjj = date.split(".")
    return datetime.date(int(jjjj),int(mm),int(tt))

def encodeFach(name):
    # Read fach, if not there, return new.
    fobs = fach.select(fach.q.name == name)
    try:
        return fobs[0]
    except:
        return fach(name=name)

for line in openData("data.csv"):
    try:
        # Get old user and update.
        user = users.select(users.q.matnr == int(line[3].strip()))[0]
        print "Old user."
        user.vorname = line[1].strip()
        user.nachname = line[0].strip()
        user.gebdat = parseDate(line[2].strip()[:10])
        user.semester = int(line[5].strip())
        user.fach = encodeFach(line[4].strip())
        user.alias = line[6].strip().split("@")[0]
        print "After update:"
        print user
        print "="*80
    except:
        # New user, create.
        print "New user."
        u = users(
            # Vorname und Nachname sind in 1+0.
            vorname=line[1].strip(),nachname=line[0].strip(),

            # Geburtsdatum, Semester und Fach sind in 2, 7 und 4.
            gebdat=parseDate(line[2].strip()[:10]),
            semester=int(line[5].strip()),fach=encodeFach(line[4].strip()),

            # Matrikelnummer und Alias sind in 3 und 6,
            # Startkennwort ist Geburtsdatum.
            matnr=int(line[3].strip()),alias=line[6].strip().split("@")[0],
            passwd=line[2].strip()[:10]
        )
        print "After insert:"
        print user
        print "="*80
