# -*- coding: iso-8859-15 -*-
"""data_update.py

Implements the standard aliases of the form vorname[2], nachname[2], number
for all users.

Copyright (C) 2005, Heiko Wundram.
"""

import random
import re
import studauthd_db

def subSpecial(name):
    # Little function to write out Umlauts, and to strip all other invalid
    # chars.
    name = name.lower().replace("","ae").replace("","oe").replace("","ue")
    name = re.sub("[^a-z]","",name)

    return name

def createName(uitem):
    return "%s%s%03i" % (subSpecial(uitem.vorname)[:2],
                         subSpecial(uitem.nachname)[:2],
                         random.randrange(100,1000))

def main():
    for uitem in studauthd_db.user.select():
        # Create new alias for this user.
        while True:
            alias = createName(uitem)
            try:
                studauthd_db.alias.select(studauthd_db.alias.q.alias==alias)[0]
            except IndexError:
                break

        print alias
        print uitem

        # Loop over existing aliases.
        for aitem in uitem.aliases:
            if aitem.aliastype == 1:
                break
        else:
            # None exists, create primary.
            studauthd_db.alias(alias=alias,aliastype=1,user=uitem)

# Run main only if called.
if __name__ == "__main__":
    main()
