# -*- coding: iso-8859-15 -*-
"""send_newmail.py

Sends a certain mail to all registered users. This is primarily used to send
updates to registered users, such as the "alias-update" mail.

Copyright (C) 2005, Heiko Wundram.
"""

# Imports.
import config
import os
import smtplib
import studauthd_db
import sys

# List existing users.
def listMatNr():
    for name in os.listdir(config.VMAIL_HOME):
        yield int(name)

def getInfo(matnr):
    return studauthd_db.user.select(studauthd_db.user.q.matnr==matnr)[0]

def sendMail(mail,matnr):
    try:
        user = getInfo(matnr)
        print "Mail an:", user
        mailer = smtplib.SMTP("localhost")
        mailer.sendmail("admin@asta.mh-hannover.de",
                        ["%s%%%s" % (user.matnr,config.VMAIL_DOMAIN)],
                        mail % {"alias":user.alias,"vorname":user.vorname})
    except Exception, e:
        print e, repr(e)

def main():
    mail = file(sys.argv[1],"r").read()
    for matnr in listMatNr():
        sendMail(mail,matnr)

if __name__ == "__main__":
    main()
