/* PyAuthD_ppp.h
   --------------

   Constants that are required for the pppd binding of PyAuthD.

   Copyright (C) 2005, Heiko Wundram.
   Released under a BSD-style license, see LICENSE for details.

$LastChangedBy: modelnine $
$LastChangedRevision: 76 $
$LastChangedDate: 2005-10-24 01:55:20 +0200 (pon, 24 paź 2005) $
*/

#ifndef __INCLUDE_PYAUTHD_PPP_H
#define __INCLUDE_PYAUTHD_PPP_H

/* Constants which define the different functions that may be called. */

#include "PyAuthD_constants.h"

/* pppd functions. */

void plugin_init();
void plugin_close(void *opaque, int arg);
static int PyAuthD_secret_check();
static int PyAuthD_pap_auth(char *user, char *passwd, char **msgp,
			    struct wordlist **paddrs, struct wordlist **popts);
static int PyAuthD_chap_auth(char *user, char *ourname, int id,
			     struct chap_digest_type *digest,
			     unsigned char *challenge, unsigned char *response,
			     unsigned char *message, int message_space);
static int PyAuthD_null_auth(struct wordlist **paddrs,
			     struct wordlist **popts);
static void PyAuthD_choose_ip(u_int32_t *addrp);
static int PyAuthD_allow_ip(u_int32_t addr);
static int PyAuthD_check_idle(struct ppp_idle *idlep);
static int PyAuthD_check_holdoff();
void PyAuthD_notify(void *opaque, int arg);

/* Extra definitions because of dumb pppd.h */

extern int (*null_auth_hook) __P((struct wordlist **paddrs,
				  struct wordlist **popts));

#endif /* __INCLUDE_PYAUTHD_PPP_H */
