/* PyAuthD_client.h
   ----------------

   Header file which defines important bindings for PyAuthD.

   Copyright (C) 2005, Heiko Wundram.
   Released under a BSD-style license, see LICENSE for details.

$LastChangedBy: modelnine $
$LastChangedRevision: 76 $
$LastChangedDate: 2005-10-24 01:55:20 +0200 (pon, 24 paź 2005) $
*/

#ifndef __INCLUDE_PYAUTHD_CLIENT_H
#define __INCLUDE_PYAUTHD_CLIENT_H

/* Constants which define the services that the daemon offers. */

#include "PyAuthD_constants.h"

/* Convenience macros for sending/receiving data. */

#define RECV_VALUE(v) { if( recv(sock,(void*)&v,sizeof(v),0) == -1 ) \
goto RECV_ERROR; } while(0)

#define RECV_DATA(d,dl) { if( !( d = malloc(dl+1) ) ) \
goto MEMORY_ERROR; \
if( dl && ( recv(sock,(void*)d,dl,0) == -1 ) ) \
goto RECV_ERROR; \
((char*)d)[dl] = '\0'; } while(0)

#define FREE_DATA(d,dl) { memset(d,0,dl); free(d); } while(0)

#define SEND_VALUE(v) { if( send(sock,(void*)&v,sizeof(v),0) == -1 ) \
goto SEND_ERROR; } while(0)

#define SEND_DATA(d,dl) { dl = strlen((char*)d); \
if( send(sock,(void*)&dl,sizeof(dl),0) == -1 ) \
goto SEND_ERROR; \
if( dl && ( send(sock,d,dl,0) == -1 ) ) \
goto SEND_ERROR; } while(0)

/* Functions defined in PyAuthD_client.c */

int openPyAuthD(int remotetype);
void closePyAuthD(int sock);

#endif /* __INCLUDE_PYAUTHD_CLIENT_H */
