# -*- coding: iso-8859-15 -*-
"""Postfix_constants.py

(Autogenerated) file which contains all constants necessary for the Postfix
binding.

Copyright (C) 2005, Heiko Wundram.
Released under a BSD-style license, see LICENSE for details.
"""

# Versioning.
__author__ = "$LastChangedBy: modelnine $"
__version__ = "$LastChangedRevision: 103 $"
__date__ = "$LastChangedDate: 2005-10-28 19:56:08 +0200 (pią, 28 paź 2005) $"

# Python imports.

import os
import re
import sys

# Defines.

SPLIT_RE = "[^a-zA-Z0-9\(\)\<\>_]+"

# Function which imports Postfix constants from headers. Gets passed dict.h as
# sys.argv[1].

def _declareConstants():
    constants = file(sys.argv[0],"r+")
    pos = 0

    # Find file position for starting items.
    while True:
        line = constants.readline()
        if not line:
            raise ValueError, "Invalid source file."

        pos += len(line)
        if line == "# --- CODE END ---\n":
            break

    # Go there.
    constants.seek(pos)

    # Make sure we can actually read file, if not, just continue.
    try:
        incfile = open(sys.argv[1],"r")
    except:
        raise ValueError, "Cannot open input file!"

    # Read lines, find ones which start with "#define", and extract
    # data.
    for line in incfile:
        # Remove Preprocessor signature.
        line = line.lstrip()
        if not line.startswith("#"):
            continue

        # Split command and rest.
        try:
            command, rest = re.split(SPLIT_RE,line[1:],1)
            if command <> "define":
                continue
        except:
            # Rest couldn't be split off, continue.
            continue

        # Try to split off name and value.
        try:
            name, value, comment = re.split(SPLIT_RE,rest,2)
        except:
            try:
                name, value = re.split(SPLIT_RE,rest,1)
            except:
                continue

        # Check name.
        if not name.startswith("DICT_"):
            continue
        name = name[5:]

        # Check value.
        try:
            value = eval(value)
        except:
            continue

        # Write out to incfile.
        constants.write("%s = %r\n" % (name,value))

    # Truncate incfile.
    constants.truncate()

# Call function when declaring constants.
if __name__ == "__main__":
    _declareConstants()

# NO PERSONAL CHANGES BEHIND THIS POINT!
# --- CODE END ---
FLAG_NONE = 0
FLAG_DUP_WARN = 1
FLAG_DUP_IGNORE = 2
FLAG_TRY0NULL = 4
FLAG_TRY1NULL = 8
FLAG_FIXED = 16
FLAG_PATTERN = 32
FLAG_LOCK = 64
FLAG_DUP_REPLACE = 128
FLAG_SYNC_UPDATE = 256
FLAG_DEBUG = 512
FLAG_FOLD_KEY = 1024
FLAG_NO_REGSUB = 2048
FLAG_NO_PROXY = 4096
FLAG_NO_UNAUTH = 8192
ERR_NONE = 0
ERR_RETRY = 1
SEQ_FUN_FIRST = 0
SEQ_FUN_NEXT = 1
