# -*- coding: iso-8859-15 -*-
"""studauthd.py

Implementation of the PyAuthD handler for student server operation. This
creates the appropriate handler class with all mixins loaded.

Copyright (C) 2005, Heiko Wundram.
Released under a BSD-style license, see LICENSE for details.
"""

# Versioning.
__author__ = "$LastChangedBy: modelnine $"
__version__ = "$LastChangedRevision: 163 $"
__date__ = "$LastChangedDate: 2005-11-10 18:18:48 +0100 (czw, 10 lis 2005) $"

# Our modules required by the studserv authentication daemon.

import config
from constants import *
import daemonize
# import log TODO!
import pyauthd_serv
import pyauthd_pam
import pyauthd_nss
import pyauthd_postfix
import pyauthd_squirrelmail
import pyauthd_ppp
import studauthd_db

# Client class for our PyAuthD.

class StudClient(pyauthd_pam.PamMixin,pyauthd_nss.NssMixin,
                 pyauthd_postfix.PostfixMixin,
                 pyauthd_squirrelmail.SquirrelmailMixin,
                 pyauthd_ppp.PPPMixin,
                 pyauthd_serv.BasePyAuthDClient):

    def getUser(self,name):
        return studauthd_db.User.getUser(name)

    def getUid(self,uid):
        return studauthd_db.User.getUid(uid)

    def listUsers(self):
        def priviter():
            raise StopIteration
        return priviter
        # ? This shouldn't run because it creates all accounts.
        # return studauthd_db.User.listUsers()

    def virtualLookup(self,key):
        try:
            return studauthd_db.User.getAlias(key).getPasswd().name
        except KeyError:
            # Split name and domain.
            try:
                name, domain = key.split("@")
            except:
                raise KeyError

            # Check domain.
            if domain <> config.VMAIL_DOMAIN:
                raise KeyError

            # TODO: Dirty hack for now to just map old mails back to fenrir.
            return "%s@fenrir.stud.mh-hannover.de" % (name,)

# Create and dispatch server.
if __name__ == "__main__":
    # Daemonize and start log.
    # log.start() TODO, write log!
    # daemonize.daemonize(), keep from daemonizing for now...

    # Create server and serve. The error message in case the server can't be
    # created is dumped to the log file.
    serv = pyauthd_serv.PyAuthDServer(SOCK_PATH,StudClient)
    serv.serve_until_quit()

    # Server has finished. Close log. Falling off this end just stops the
    # server.
    # log.stop() TODO, write log!
